Redmine - Defect #29247

Textile phrase modifiers break wiki macros
2018-07-18 16:28 - Stephan Wenzel
Category: Text formatting Estimated time: 0.00 hour
Target version: 3.4.7

Resolution: Fixed Affected version: 3.4.6
Description

redcloth.rb, Redmine's textile interpreter, has a long standing bug or "glitch". That glitch relates to using modifiers (bold, italic,
underline, etc.) together with a macro.

*{{user(1l)}}~*
will not produce the desired result, namely a link to a user in bold face. Instead, it will produce a "}" in boldface like here: {{}}
| propose the following fix to lib/redmine/wiki_formatting/textile/redcloth3.rb:

346¢c346, 347

< C_STYL = "(2:\{[""}]1+\})"
> # C_STYL = "(2:\{[""}]1+\})"
> C_STYL = "(2:\{["{1[""}]1+\})"'

The proposed fix will catch double curly brackets and still apply styles (boldface, underline, italic, etc.)

Associated revisions

Revision 17450 - 2018-07-21 02:16 - Go MAEDA

Fix: Textile phrase modifiers break wiki macros (#29247).

Patch by Stephan Wenzel.

Revision 17451 - 2018-07-21 02:17 - Go MAEDA
Merged r17450 from trunk to 3.4-stable (#29247).

History

#1 - 2018-07-19 02:48 - Go MAEDA

- File 29247.patch added

- Subject changed from Long standing bug in redcloth.rb and proposal for solution to Textile phrase modifiers break wiki macros
- Status changed from New to Confirmed

Confirmed the issue in Textile mode. No problem in Markdown mode.

| added a test which can catch the issue to Stephan Wenzel's patch.

#2 - 2018-07-19 09:52 - Gregor Schmidt

Disclaimer: | don't know a lot about the inner workings of redcloth.

| can see, how the proposed change fixes the problem at hand. | assume it does not have negative side effects.

The C_STYLE var seems to be used to match css style expressions, e.g. p{background:red}. Red paragraph. After the change, expressions that start
with { are no longer matched. This should not be a problem. As far as | can tell, { will never appear at the beginning of such an expression.

That being said, | don't see a reason, to reject the proposed change.

#3 - 2018-07-19 11:20 - Go MAEDA
- Target version set to 3.4.7

Gregor, thank you for reviewing the patch. | am setting the target version to 3.4.7.

#4 - 2018-07-21 02:18 - Go MAEDA
- Status changed from Confirmed to Closed
- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed. Thank you for your contribution.

Files

29247 .patch 1.12KB 2018-07-19 Go MAEDA
